------------------------------------------------------------------------------
--                              Ada Web Server                              --
--                                                                          --
--                     Copyright (C) 2012-2014, AdaCore                     --
--                                                                          --
--  This library is free software;  you can redistribute it and/or modify   --
--  it under terms of the  GNU General Public License  as published by the  --
--  Free Software  Foundation;  either version 3,  or (at your  option) any --
--  later version. This library is distributed in the hope that it will be  --
--  useful, but WITHOUT ANY WARRANTY;  without even the implied warranty of --
--  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.                    --
--                                                                          --
--                                                                          --
--                                                                          --
--                                                                          --
--                                                                          --
--  You should have received a copy of the GNU General Public License and   --
--  a copy of the GCC Runtime Library Exception along with this program;    --
--  see the files COPYING3 and COPYING.RUNTIME respectively.  If not, see   --
--  <http://www.gnu.org/licenses/>.                                         --
--                                                                          --
--                                                                          --
--                                                                          --
--                                                                          --
--                                                                          --
--                                                                          --
--                                                                          --
------------------------------------------------------------------------------

with Interfaces.C;

package AWS.Net.SSL.Certificate.Impl is

   use Interfaces;

   function Get (Socket : Socket_Type) return Object;
   --  Read certificate from peer socket

   function Load (Filename : String) return Object;
   --  Load certificate data from file

   function Read
     (Status : C.int; X509 : Standard.SSL.Thin.X509) return Object;
   --  Read certificate data

   function Status_String (Status : C.long) return String;
   --  Returns the message string for status

   function Error_Stack return String;
   --  Returns error stack of the last SSL error in multiple lines

   function Error_Str (Code : Standard.SSL.Thin.Error_Code) return String;
   --  Returns the SSL error message for error Code

end AWS.Net.SSL.Certificate.Impl;
